# === TAGGER PLUGIN =================================
# ====== CREATED BY CRAZIEST ========================
# ========= EDIT THE SETTINGS IN CONFIG.CFG =========
# ============ DO NOT EDIT THIS FILE!!!!!!!!!!! =====

''' Necessary Imports '''
import es
import cmdlib
import cfglib
from path import path
import cPickle

''' Addon Information '''
info = es.AddonInfo()
info.name = 'Tagger'
info.version = '1.0'
info.basename = 'tagger'
info.author = 'Craziest'
info.description = 'Set your own personal tag and show it to others!'

es.ServerVar("tagger_version", info.version).makepublic()

''' Variable Declarations '''
tagDict = {}

cfg = cfglib.AddonCFG(es.getAddonPath("tagger") + "/config/tagger.cfg")

cfg.text("******************************")
cfg.text("****** TAGGER SETTINGS *******")
cfg.text("******** BY CRAZIEST *********")

tagCommand = cfg.cvar('tag_command', '!tag', 'The command which shows the tags and allows configuration and help')
tagAnnounce = cfg.cvar('tag_announce', 1, 'Announce every 3 rounds the plugin is running with instructions on how to use')
tagShow = cfg.cvar('tag_show', 1, 'Tell new players how to use tags when they come ingame?')
tagShowTag = cfg.cvar('tag_show_connect', 1, 'Broadcast the players tag when he connects (if he has one)')
tagSave = cfg.cvar('tag_save', 1, 'Save the tags on mapstart/unload so the players don\'t have to write them each time.')

cfg.write()

''' Load / Unload Functions '''
def load():
    global tagDict
    cmdlib.registerSayCommand(tagCommand, tagCmd, "Tagger Plugin Command")
    cfg.execute()
    for x in es.getUseridList():
        uid = es.getplayersteamid(x)
        if uid not in tagDict:
            tagDict[uid] = {}
            tagDict[uid]['tag'] = None
    if tagSave == 1:
        dbOpen()
    
def unload():
    cmdlib.unregisterSayCommand(tagCommand)
    if tagSave == 1:
        dbSave()
    
''' Event Functions '''
def es_map_start(ev):
    if tagSave == 1:
        dbSave()
        
def player_connect(ev):
    uid = ev['networkid']
    
    if uid not in tagDict:
        tagDict[uid] = {}
        tagDict[uid]['tag'] = None
        
def player_activate(ev):
    global tagDict
    userid = int(ev['userid'])
    uid = es.getplayersteamid(userid)
    
    if tagDict[uid]['tag'] != None:
        if tagShowTag:
            es.msg('#multi', '#green--- #lightgreen' + es.getplayername(userid) + '#green : ' + tagDict[uid]['tag'])
    
def player_spawn(ev):
    userid = int(ev['userid'])
    uid = es.getplayersteamid(userid)
    
    if tagDict[uid]['tag'] == None:
        es.tell(userid, '#multi', '#green--- Type #lightgreen%s info #greento see information on how to set your tag.' % tagCommand)

''' Command Functions '''
def tagCmd(userid, args):
    uid = es.getplayersteamid(userid)
    if args:
        if args[0].lower().startswith('set'):
            sargs = str(args)
            tag = sargs[3:].strip().capitalize()
            tagDict[uid]['tag'] = tag
            es.tell(userid, '#multi', '#green--- You have set your tag to : #green%s' % str(tagDict[uid]['tag']))
        elif args[0].lower().startswith('info'):
            es.tell(userid, '#multi', '#green--- Set your tag : #lightgreen%s set <text>#green, view player tags : #lightgreen%s <name>#green or help : #lightgreen%s info' % (tagCommand, tagCommand, tagCommand))
        elif es.getuserid(args):
            target = es.getuserid(args)
            tid = es.getplayersteamid(target)
            if tid in tagDict and tagDict[tid]['tag'] not in (0, None):
                es.msg('#multi', '#green--- #lightgreen' + es.getplayername(target) + '#green : ' + tagDict[tid]['tag'])
            else:
                es.tell(userid, '#multi', '#green--- #lightgreen%s #greenhasn\'t gotten a crazy tag set up!' % es.getplayername(target))
            
        else:
            es.tell(userid, '#multi', '#green--- Set your tag : #lightgreen%s set <text>#green, view player tags : #lightgreen%s <name>#green or help : #lightgreen%s info' % (tagCommand, tagCommand, tagCommand))
        
    else:
        if tagDict[uid]['tag']:
            es.msg('#multi', '#green--- #lightgreen' + es.getplayername(userid) + '#green : ' + tagDict[uid]['tag'])
        else:
            es.tell(userid,'#multi', '#green--- You can set your tag with : #lightgreen%s set <text>' % tagCommand)
            
''' Database Handling '''   
def dbSave():
    p = open(es.getAddonPath("tagger") + '/tags.db', 'wb')
    cPickle.dump(tagDict, p)
    p.close()
    
def dbOpen():
    global tagDict
    p = es.getAddonPath("tagger") + '/tags.db'
    if path(p).isfile():
        f = open(p, 'rb')
        tagDict = cPickle.load(f)
        f.close()